package com.ruoyi.bst.bonusRefund.mapper;

import com.ruoyi.bst.bonusRefund.domain.BonusRefund;
import com.ruoyi.bst.bonusRefund.domain.BonusRefundQuery;
import com.ruoyi.bst.bonusRefund.domain.BonusRefundVO;
import com.ruoyi.bst.bonusRefund.domain.vo.BonusRefundDailyStatVO;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;

/**
 * 分成退款记录Mapper接口
 *
 * @author ruoyi
 * @date 2025-01-25
 */
public interface BonusRefundMapper
{
    /**
     * 查询分成退款记录
     *
     * @param id 分成退款记录主键
     * @return 分成退款记录
     */
    BonusRefundVO selectBonusRefundById(Long id);

    /**
     * 查询分成退款记录列表
     *
     * @param query 分成退款记录
     * @return 分成退款记录集合
     */
    List<BonusRefundVO> selectBonusRefundList(@Param("query")BonusRefundQuery query);

    /**
     * 新增分成退款记录
     *
     * @param bonusRefund 分成退款记录
     * @return 结果
     */
    int insertBonusRefund(BonusRefund bonusRefund);

    /**
     * 批量新增分成退款记录
     */
    int batchInsert(@Param("list") List<? extends BonusRefund> list);

    /**
     * 批量修改分成退款记录
     */
    int batchUpdate(@Param("list") List<? extends BonusRefund> list);

    /**
     * 修改分成退款记录
     *
     * @param bonusRefund 分成退款记录
     * @return 结果
     */
    public int updateBonusRefund(@Param("data") BonusRefund bonusRefund);

    /**
     * 删除分成退款记录
     *
     * @param id 分成退款记录主键
     * @return 结果
     */
    int deleteBonusRefundById(Long id);

    /**
     * 批量删除分成退款记录
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteBonusRefundByIds(Long[] ids);

    /**
     * 查询分成退款金额
     *
     * @param query 分成退款记录查询条件
     * @return 分成退款金额
     */
    BigDecimal selectSumOfAmount(@Param("query") BonusRefundQuery query);

    /**
     * 查询分成退款每日统计
     */
    List<BonusRefundDailyStatVO> selectDailyStat(@Param("query") BonusRefundQuery query, @Param("keys") List<String> keys);
}
